Bug 464963 - FTBFS perl-CGI-SpeedyCGI-2.22-2.fc10
FTBFS perl-CGI-SpeedyCGI-2.22-2.fc10
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: perl-CGI-SpeedyCGI (Show other bugs)
rawhide
All Linux
high Severity high
: ---
: ---
Assigned To: Robert Scheck
Fedora Extras Quality Assurance
http://linux.dell.com/files/fedora/Fi...
:
Depends On:
Blocks: F10FTBFS
  Show dependency treegraph
 
Reported: 2008-10-01 11:43 EDT by FTBFS
Modified: 2008-10-13 08:11 EDT (History)
3 users (show)

See Also:
Fixed In Version: 2.22-3
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-10-13 08:11:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
root.log (561.11 KB, text/plain)
2008-10-01 11:43 EDT, FTBFS
no flags Details
build.log (48.89 KB, text/plain)
2008-10-01 11:43 EDT, FTBFS
no flags Details
mock.log (969 bytes, text/plain)
2008-10-01 11:43 EDT, FTBFS
no flags Details
root.log (677.46 KB, text/plain)
2008-10-01 11:43 EDT, FTBFS
no flags Details
build.log (48.13 KB, text/plain)
2008-10-01 11:43 EDT, FTBFS
no flags Details
mock.log (915 bytes, text/plain)
2008-10-01 11:43 EDT, FTBFS
no flags Details
Patch to remove inline definitions to fix current FTBFS issues (8.06 KB, patch)
2008-10-10 20:27 EDT, Andreas Thienemann
no flags Details | Diff
Better version, doing a full cleanup of the inline definitions (8.47 KB, patch)
2008-10-10 20:31 EDT, Andreas Thienemann
no flags Details | Diff

  None (edit)
Description FTBFS 2008-10-01 11:43:08 EDT
perl-CGI-SpeedyCGI-2.22-2.fc10.src.rpm Failed To Build From Source against the rawhide tree.  See http://fedoraproject.org/wiki/FTBFS for more information.
Comment 1 FTBFS 2008-10-01 11:43:12 EDT
Created attachment 318293 [details]
root.log

root.log for i386
Comment 2 FTBFS 2008-10-01 11:43:13 EDT
Created attachment 318294 [details]
build.log

build.log for i386
Comment 3 FTBFS 2008-10-01 11:43:14 EDT
Created attachment 318295 [details]
mock.log

mock.log for i386
Comment 4 FTBFS 2008-10-01 11:43:15 EDT
Created attachment 318296 [details]
root.log

root.log for x86_64
Comment 5 FTBFS 2008-10-01 11:43:17 EDT
Created attachment 318297 [details]
build.log

build.log for x86_64
Comment 6 FTBFS 2008-10-01 11:43:18 EDT
Created attachment 318298 [details]
mock.log

mock.log for x86_64
Comment 7 Robert Scheck 2008-10-09 02:42:45 EDT
John, do you also have a suggestion how to solve that? I know, that it is broken, but nobody came up with a solution, even fedora-devel-list ignored
that silently.
Comment 8 Andreas Thienemann 2008-10-10 20:26:05 EDT
As discussed on IRC:

[01:39] < ixs> rsc: found it. please wait for a patch.
[01:40] < rsc> ixs: sooo fast?
[01:43] < ixs> yeah, it's a problem with the new compiler. gcc seems to have changed it's understanding of inline functions which are 
               optimized into oblivion. the patch changes these inline functions into external ones, making the thing compile. It's dirty 
               and someone should fix it up in order to be conditional or so depending on the compiler understanding of inlineness, but it 
               should work for now.
[01:43] < ixs> http://www.greenend.org.uk/rjk/2003/03/inline.html
[01:46] < ixs> rsc: http://www.nabble.com/inline-functions-with-gnu99-td16231641.html is a good description of the problem.

The offending functions are defined as SPEEDY_INLINE which is a macro extending to __inline__ when compiled as gcc.

The quickfix is to drop the following lines at the end of the %prep macro, removing this macro:

# DIRTYFIX - Clean out all references to SPEEDY_INLINE in order to fix
# problems with current gcc builds
sed -i -e 's/#define SPEEDY_INLINE __inline__/#define SPEEDY_INLINE/' src/speedy_inc.h

An alternative patch doing the same in a somewhat saner way is attached.

My reading of the gcc manpage is that -O3 would most likely optimize the code in a similar way then manually defining inline would do. You might want to look into this.

Anyway, it works for now:

Wrote: /builddir/build/RPMS/perl-CGI-SpeedyCGI-2.22-2.fc10.x86_64.rpm
Wrote: /builddir/build/RPMS/mod_speedycgi-2.22-2.fc10.x86_64.rpm
Wrote: /builddir/build/RPMS/perl-CGI-SpeedyCGI-debuginfo-2.22-2.fc10.x86_64.rpm
Comment 9 Andreas Thienemann 2008-10-10 20:27:08 EDT
Created attachment 320079 [details]
Patch to remove inline definitions to fix current FTBFS issues
Comment 10 Andreas Thienemann 2008-10-10 20:31:44 EDT
Created attachment 320080 [details]
Better version, doing a full cleanup of the inline definitions
Comment 11 Robert Scheck 2008-10-13 08:11:29 EDT
Package: perl-CGI-SpeedyCGI-2.22-3.fc10 Tag: dist-f10 Status: complete Built by: robert

Note You need to log in before you can comment on or make changes to this bug.